#ifndef __DATAFLOW_H__
#define __DATAFLOW_H__

#define	CF_VERSION	"0.2.0"

#pragma comment (lib, "psapi.lib")
#pragma comment (lib, "ntdll.lib")

#define ibaseDD *(PDWORD)&ibase
#define MAX_FNI_LENGTH						MAX_PATH*4
#define	ObjectNameInformation			1
#define	MAX_APINAME_SIZE	200

#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

#ifdef __cplusplus
extern "C"
{
#endif

	LONG//NTSTATUS
	WINAPI
	NtQueryObject (
		HANDLE ObjectHandle,
		DWORD ObjectInformationClass,
		PVOID ObjectInformation,
		ULONG ObjectInformationLength,
		PULONG ReturnLength
	);

#ifdef __cplusplus
}
#endif


typedef struct _UNICODE_STRING
{
	USHORT Length;
	USHORT MaximumLength;
	PWSTR  Buffer;
} UNICODE_STRING;

inline DWORD ReadContext ( HANDLE hThread, CONTEXT *ctx )
{
	if ( !ctx ) return 0;
	ctx->ContextFlags = CONTEXT_FULL | CONTEXT_DEBUG_REGISTERS;
	return GetThreadContext ( hThread, ctx );
}

typedef struct _OBJECT_NAME_INFORMATION
{
	UNICODE_STRING Name;
}OBJECT_NAME_INFORMATION, *POBJECT_NAME_INFORMATION;

#endif // __DATAFLOW_H__